package com.mongo.reactivie.model.deserializer;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.mongo.reactivie.model.JobPost;
import java.util.Optional;
import org.apache.kafka.common.header.Headers;
import org.apache.kafka.common.serialization.Deserializer;
import org.springframework.stereotype.Component;

@Component
public class JobPostDeserializer implements Deserializer<JobPost> {


    @Override
    public JobPost deserialize(String arg0, byte[] arg1) {
        ObjectMapper mapper = new ObjectMapper();
        JobPost jobPost = new JobPost();
        try {
            JsonNode orderNode = mapper.readTree(arg1);
            if (Optional.ofNullable(orderNode).isPresent()) {
                constructJobPost(jobPost, orderNode);
            }
        } catch (Exception e) {

        }
        return jobPost;
    }

    private void constructJobPost(JobPost jobPost, JsonNode jsonNode)
            throws JsonMappingException, JsonProcessingException {
        jobPost.setId(getTextValue(jsonNode, "id"));
        jobPost.setDesc(getTextValue(jsonNode, "desc"));
        jobPost.setExp((getIntValue(jsonNode, "exp")));
        jobPost.setProfile(getTextValue(jsonNode, "profile"));

    }

    private String getTextValue(JsonNode jsonNode, String key) {
        return Optional.ofNullable(jsonNode.get(key)).map(JsonNode::textValue).orElse(null);
    }

    private Integer getIntValue(JsonNode jsonNode, String key) {
        return Optional.ofNullable(jsonNode.get(key)).map(JsonNode::intValue).orElse(null);
    }

    @Override
    public JobPost deserialize(String arg0, Headers arg1, byte[] arg2) {
        return this.deserialize(arg0, arg2);
    }

}
