package com.mongo.reactivie.repository;

import com.mongo.reactivie.model.JobPostCompanyDetails;
import com.mongodb.client.AggregateIterable;
import com.mongodb.client.MongoClient;
import com.mongodb.client.MongoCollection;
import com.mongodb.client.MongoDatabase;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import org.bson.Document;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.convert.MongoConverter;
import org.springframework.stereotype.Component;

@Component
public class JobPostDAOImpl {

    @Autowired
    private MongoClient mongoClient;

    @Autowired
    MongoConverter converter;

    public List<JobPostCompanyDetails> getJobPostCompanyDetails() {

        final List<JobPostCompanyDetails> posts = new ArrayList<>();
        MongoDatabase database = mongoClient.getDatabase("Job");
        MongoCollection<Document> collection = database.getCollection("JobPost");

        AggregateIterable<Document> result = collection.aggregate(Arrays.asList(new Document("$lookup",
                new Document("from", "Company")
                        .append("localField", "companyId")
                        .append("foreignField", "_id")
                        .append("as", "companyDetails"))));
        result.forEach(doc -> posts.add(converter.read(JobPostCompanyDetails.class,doc)));
        return posts;
    }
}